#include <stdlib.h>
#include <stdio.h>
#include <sys/mman.h>
#include <unistd.h>
#include <string.h>

#define MMINSP 134 //this depends on what the kernel tells you when mounting the mm-inpector module

int mm_inspector(unsigned long x, int y){
	return syscall(MMINSP,x,y);
}

int main(int argc, char** argv){
        
       	int ret;
	char* buff;
	long flags;

	if (argc != 2){
		printf("usage: prog memory-access-mode (read/write/exec/all)\n");
		exit(EXIT_FAILURE);
	}
	if (!strcmp(argv[1],"read")) { flags = PROT_READ; goto do_work;}
	if (!strcmp(argv[1],"write")) { flags = (PROT_READ | PROT_WRITE); goto do_work;}
	if (!strcmp(argv[1],"exec")) { flags = PROT_EXEC; goto do_work;}
	if (!strcmp(argv[1],"all")) { flags = (PROT_EXEC | PROT_WRITE | PROT_EXEC); goto do_work;}
	printf("invalid argument\n");
	exit(EXIT_FAILURE);

do_work:
	buff = mmap(NULL, 4096, flags, MAP_PRIVATE|MAP_ANONYMOUS, 0, 0); 

       	ret = mm_inspector((unsigned long)buff,0);
	printf("address %p mapped: %d - read only query\n",buff,ret);

       	ret = mm_inspector((unsigned long)buff,1);
	printf("address %p mapped: %d - read/write query\n",buff,ret);

       	ret = mm_inspector((unsigned long)buff,2);
	printf("address %p mapped: %d - exec query\n",buff,ret);


}

